// Internal Constants
const string MYSTERY_USES   = "PRC_MystUses";
const string MYSTERY_BONUS_USES   = "PRC_MystBonusUses";
const string MYST_HOLD_MYST = "MYST_HOLD_MYST";

// AoE Constants
const int AOE_PER_CARPET_SHADOW     = 108;
const int AOE_PER_DUSK_AND_DAWN     = 107;
const int AOE_PER_BLACKFIRE         = 106;
const int AOE_PER_CLINGING_DARKNESS = 105;
const int AOE_PER_CURTAIN_SHADOWS   = 104;
const int AOE_PER_FLOOD_SHADOW      = 103;
const int AOE_PER_PLAGUE_SHADOW     = 102;

// Paths
const int PATH_CLOAK_SHADOWS         = 1;
const int PATH_DARK_TERRAIN          = 2;
const int PATH_EBON_WHISPERS         = 3;
const int PATH_EYES_DARKNESS         = 4;
const int PATH_SHUTTERS_CLOUDS       = 5;
const int PATH_TOUCH_TWILIGHT        = 6;
const int PATH_UMBRAL_MIND           = 7;
const int PATH_BLACK_MAGIC           = 8;
const int PATH_BODY_SOUL             = 9;
const int PATH_DARK_REFLECTIONS      = 10;
const int PATH_EBON_ROADS            = 11;
const int PATH_ELEMENTAL_SHADOWS     = 12;
const int PATH_UNBINDING_SHADE       = 13;
const int PATH_VEIL_SHADOWS          = 14;
const int PATH_BREATH_TWILIGHT       = 15;
const int PATH_DARK_METAMORPHOSIS    = 16;
const int PATH_EBON_WALLS            = 17;
const int PATH_EYES_NIGHT_SKY        = 18;
const int PATH_HEART_SOUL            = 19;
const int PATH_SHADOW_CALLING        = 20;
const int PATH_NIGHTS_LONG_FINGERS   = 21;
const int PATH_DARKENED_ALLEYS       = 22;
const int PATH_SHADOWSCAPE           = 23;

// Fundamentals
const int FUND_ARROW_DUSK            = 18521;
const int FUND_BLACK_CANDLE_LIGHT    = 18523;
const int FUND_BLACK_CANDLE_DARK     = 18524;
const int FUND_CAUL_SHADOW           = 18525;
const int FUND_MYSTIC_REFLECTIONS    = 18526;
const int FUND_SHADOW_HOOD           = 18527;
const int FUND_SIGHT_OBSCURED        = 18528;
const int FUND_UMBRAL_HAND           = 18529;
const int FUND_WIDENED_EYES          = 18530;

// Level 1 Mysteries - Apprentice
const int MYST_BEND_PERSPECTIVE      = 18352;
const int MYST_CARPET_SHADOW         = 18353;
const int MYST_DUSK_AND_DAWN_DUSK    = 18354;
const int MYST_DUSK_AND_DAWN_DAWN    = 18355;
const int MYST_LIFE_FADES            = 18356;
const int MYST_MESMERIZING_SHADE     = 18357;
const int MYST_STEEL_SHADOWS         = 18358;
const int MYST_VOICE_SHADOW_APPROACH = 18359;
const int MYST_VOICE_SHADOW_DROP     = 18360;
const int MYST_VOICE_SHADOW_FALL     = 18361;
const int MYST_VOICE_SHADOW_FLEE     = 18362;
const int MYST_VOICE_SHADOW_HALT     = 18363;
const int MYST_QUICKER_THAN_THE_EYE  = 18580;

// Level 2 Mysteries
const int MYST_BLACK_FIRE            = 18364;
const int MYST_CONGRESS_SHADOWS      = 18365;
const int MYST_FLESH_FAILS_STR       = 18366;
const int MYST_FLESH_FAILS_DEX       = 18367;
const int MYST_FLESH_FAILS_CON       = 18368;
const int MYST_PIERCING_SIGHT        = 18369;
const int MYST_SHADOW_SKIN           = 18370;
const int MYST_SIGHT_ECLIPSED        = 18371;
const int MYST_THOUGHTS_SHADOW_INT   = 18372;
const int MYST_THOUGHTS_SHADOW_WIS   = 18373;
const int MYST_THOUGHTS_SHADOW_CHA   = 18374;
const int MYST_TRAIL_OF_HAZE         = 18581;

// Level 3 Mysteries
const int MYST_AFRAID_DARK           = 18375;
const int MYST_CLINGING_DARKNESS     = 18376;
const int MYST_DANCING_SHADOWS       = 18377;
const int MYST_FLICKER               = 18378;
const int MYST_KILLING_SHADOWS       = 18379;
const int MYST_SHARP_SHADOWS         = 18380;
const int MYST_UMBRAL_TOUCH          = 18381;
const int MYST_UMBRAL_FIST           = 18582;
const int MYST_UMBRAL_FIST_BULL_RUSH = 18606;
const int MYST_UMBRAL_FIST_DISARM    = 18607;
const int MYST_UMBRAL_FIST_TRIP      = 18608;

// Level 4 Mysteries - Initiate
const int MYST_AURA_OF_SHADE         = 18382;
const int MYST_BOLSTER               = 18383;
const int MYST_SHADOW_EVOCATION      = 18384;
const int MYST_SHADOW_EVOCATION_CONV = 18385;
const int MYST_SHADOW_VISION         = 18386;
const int MYST_SHADOWS_FADE          = 18387;
const int MYST_STEP_SHADOW_SELF      = 18388;
const int MYST_STEP_SHADOW_PARTY     = 18389;
const int MYST_WARP_SPELL            = 18390;
const int MYST_FEARFUL_GLOOM         = 18583;

// Level 5 Mysteries
const int MYST_CURTAIN_SHADOWS       = 18391;
const int MYST_DARK_AIR              = 18392;
const int MYST_ECHO_SPELL            = 18393;
const int MYST_FEIGN_LIFE            = 18394;
const int MYST_LANGUOR_SLOW          = 18395;
const int MYST_LANGUOR_HOLD          = 18396;
const int MYST_PASS_SHADOW_SELF      = 18397;
const int MYST_PASS_SHADOW_PARTY     = 18398;
const int MYST_UNRAVEL_DWEOMER       = 18399;
const int MYST_SICKENING_SHADOW      = 18584;

// Level 6 Mysteries
const int MYST_FLOOD_SHADOW          = 18400;
const int MYST_GREATER_SHADOW_EVO      = 18401;
const int MYST_GREATER_SHADOW_EVO_CONV = 18402;
const int MYST_SHADOW_INVESTITURE    = 18403;
const int MYST_SHADOW_STORM          = 18404;
const int MYST_SHADOWS_FADE_GREATER  = 18405;
const int MYST_UNVEIL                = 18406;
const int MYST_VOYAGE_SHADOW_SELF    = 18407;
const int MYST_VOYAGE_SHADOW_PARTY   = 18408;
const int MYST_DEADLY_SHADE_DR       = 18585;
const int MYST_DEADLY_SHADE_NEG      = 18586;

// Level 7 Mysteries - Master
const int MYST_DARK_SOUL             = 18409;
const int MYST_EPHEMERAL_IMAGE       = 18410;
const int MYST_LIFE_FADES_GREATER    = 18411;
const int MYST_PRISON_NIGHT          = 18412;
const int MYST_UMBRAL_SERVANT        = 18413;
const int MYST_TRUTH_REVEALED        = 18414;
const int MYST_GRASPING_SHADOWS      = 18587;

// Level 8 Mysteries
const int MYST_FAR_SIGHT             = 18415;
const int MYST_GR_FLESH_FAILS_STR    = 18416;
const int MYST_GR_FLESH_FAILS_DEX    = 18417;
const int MYST_GR_FLESH_FAILS_CON    = 18418;
const int MYST_SHADOW_PLAGUE         = 18419;
const int MYST_SOUL_PUPPET           = 18420;
const int MYST_TOMB_NIGHT            = 18421;
const int MYST_UMBRAL_BODY           = 18422;
const int MYST_MENAGERIE_OF_DARKNESS = 18588;

// Level 9 Mysteries
const int MYST_ARMY_SHADOW           = 18423;
const int MYST_CONSUME_ESSENCE       = 18424;
const int MYST_EPHEMERAL_STORM       = 18425;
const int MYST_REFLECTIONS           = 18426;
const int MYST_SHADOW_SURGE          = 18427;
const int MYST_SHADOW_TIME           = 18428;
const int MYST_BLACK_LABYRINTH       = 18589;

// Master of Shadow
const int MYST_BID_HEAL              = 18539;
const int MYST_BID_ATTACK            = 18540;
const int MYST_BID_COLD              = 18541;
const int MYST_BID_DR                = 18542;
const int MYST_BID_SPEED             = 18543;